import { defineComponent, watch, renderSlot } from "vue";
import { useLanguage, addLanguageResources } from "./providers/UIKitProvider/contexts/LanguageProvider/useLanguageProvider.js";
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "LanguageProvider",
  props: {
    language: { default: "en-US" },
    languageResources: { default: () => [] }
  },
  setup(__props) {
    const { setLanguage } = useLanguage();
    const props = __props;
    setLanguage(props.language);
    if (props.languageResources && props.languageResources.length > 0) {
      addLanguageResources(props.languageResources);
    }
    watch(() => props.language, (newLanguage) => {
      if (newLanguage) {
        setLanguage(newLanguage);
      }
    });
    watch(() => props.languageResources, (newResources) => {
      if (newResources && newResources.length > 0) {
        addLanguageResources(newResources);
      }
    }, { deep: true });
    return (_ctx, _cache) => {
      return renderSlot(_ctx.$slots, "default");
    };
  }
});
export {
  _sfc_main as _
};
