import { defineComponent, computed, createElementBlock, openBlock, renderSlot, createCommentVNode, normalizeClass, Fragment, createTextVNode, toDisplayString } from "vue";
/* empty css                                                             */
const _hoisted_1 = { class: "tui-badge" };
const _sfc_main = /* @__PURE__ */ defineComponent({
  ...{
    name: "Badge"
  },
  __name: "index",
  props: {
    value: { default: "" },
    max: { default: 99 },
    isDot: { type: Boolean, default: false },
    hidden: { type: Boolean, default: false },
    type: { default: "danger" }
  },
  setup(__props) {
    const props = __props;
    const content = computed(() => {
      if (props.isDot) {
        return "";
      }
      if (typeof props.value === "number" && typeof props.max === "number") {
        return props.value > props.max ? `${props.max}+` : props.value;
      }
      return props.value;
    });
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", _hoisted_1, [
        renderSlot(_ctx.$slots, "default"),
        !_ctx.hidden ? (openBlock(), createElementBlock("sup", {
          key: 0,
          class: normalizeClass([
            "tui-badge-content",
            _ctx.type ? `tui-badge-${_ctx.type}` : "tui-badge-danger",
            {
              "is-dot": _ctx.isDot,
              "is-fixed": !!_ctx.$slots.default
            }
          ])
        }, [
          !_ctx.isDot ? (openBlock(), createElementBlock(Fragment, { key: 0 }, [
            createTextVNode(toDisplayString(content.value), 1)
          ], 64)) : createCommentVNode("", true)
        ], 2)) : createCommentVNode("", true)
      ]);
    };
  }
});
const TUIBadge = _sfc_main;
export {
  _sfc_main as Badge,
  TUIBadge
};
