import { defineComponent, computed, createElementBlock, openBlock, normalizeClass, renderSlot, createCommentVNode, createElementVNode, createVNode, unref } from "vue";
import { a3 as IconLoading } from "../../index-B3QCMq6W.js";
import { _ as _export_sfc } from "../../_plugin-vue_export-helper-1tPrXgE0.js";
const _hoisted_1 = ["disabled"];
const _hoisted_2 = { class: "tui-button-content" };
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "index",
  props: {
    customClasses: { default: () => [] },
    color: { default: "blue" },
    type: { default: "default" },
    autofocus: { type: Boolean },
    disabled: { type: Boolean, default: false },
    icon: {},
    iconPosition: {},
    loading: { type: Boolean, default: false },
    loadingClasses: { default: () => [] },
    shape: { default: "round" },
    size: { default: "medium" }
  },
  emits: ["click"],
  setup(__props, { emit: __emit }) {
    const emit = __emit;
    const props = __props;
    const buttonClassList = computed(() => [
      ...props.customClasses,
      "tui-button",
      `tui-button-${props.color}-${props.type}`,
      `tui-button-${props.size}`,
      `tui-button-${props.shape}`,
      { "is-disabled": props.disabled },
      { "is-loading": props.loading }
    ]);
    function handleClick(event) {
      if (!props.disabled) {
        emit("click", event);
      }
    }
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("button", {
        class: normalizeClass(buttonClassList.value),
        disabled: _ctx.disabled,
        onClick: handleClick
      }, [
        _ctx.loading ? renderSlot(_ctx.$slots, "loading", { key: 0 }, () => [
          createVNode(unref(IconLoading))
        ], true) : createCommentVNode("", true),
        createElementVNode("span", _hoisted_2, [
          renderSlot(_ctx.$slots, "default", {}, void 0, true)
        ])
      ], 10, _hoisted_1);
    };
  }
});
const Button = /* @__PURE__ */ _export_sfc(_sfc_main, [["__scopeId", "data-v-8f0c1100"]]);
const TUIButton = Button;
export {
  TUIButton
};
