import type { ButtonType } from "../Button/types";
export interface DialogEvents {
    close?: () => void;
    confirm?: () => void;
    cancel?: () => void;
}
export interface DialogOptions extends DialogEvents {
    customClasses?: string[];
    title?: string;
    content?: string;
    modal?: boolean;
    showClose?: boolean;
    center?: boolean;
    fullscreen?: boolean;
    cancelText?: string;
    confirmText?: string;
    confirmDisabled?: boolean;
    cancelDisabled?: boolean;
}
export interface DialogProps extends DialogOptions {
    visible: boolean;
}
export interface IDialogBtn {
    type?: ButtonType;
    text?: string;
    customClasses?: string[];
    action?: () => void;
    disabled?: boolean;
}
