import { defineComponent, computed, onMounted, createBlock, openBlock, Transition, withCtx, withDirectives, createElementVNode, withModifiers, normalizeClass, renderSlot, createCommentVNode, unref, toDisplayString, createTextVNode, createElementBlock, Fragment, renderList, vShow, createVNode, render } from "vue";
import { g } from "../../index.scss_vue_type_style_index_0_src_true_lang-DAMLZwbp.js";
import { TUIButton } from "../Button/index.js";
import { b0 as IconSuccessToast, a_ as IconInfoToast, a$ as IconErrorToast, aZ as IconWarningToast, E as IconClose } from "../../index-B3QCMq6W.js";
import "../Toast/index.js";
import "../hooks/useComponent.js";
/* empty css                                                             */
const _hoisted_1 = { class: "message-box-header" };
const _hoisted_2 = { class: "message-box-title" };
const _hoisted_3 = { class: "message-box-body" };
const _hoisted_4 = { class: "message-box-footer" };
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "index",
  props: {
    visible: { type: Boolean },
    title: { default: "" },
    type: { default: "" },
    content: { default: "" },
    modal: { type: Boolean, default: true },
    showClose: { type: Boolean, default: true },
    callback: { type: [Function, null], default: null },
    duration: { default: Infinity },
    cancelText: { default: "" },
    confirmText: { default: "" },
    remove: { type: Function, default: () => {
    } },
    onConfirm: {},
    onCancel: {}
  },
  emits: ["update:visible", "close", "confirm", "cancel"],
  setup(__props, { emit: __emit }) {
    let timer = null;
    const IS_PC = g() === "pc";
    const props = __props;
    const emit = __emit;
    const messageBoxClassName = computed(() => {
      const className = [
        "message-box-default",
        "message-box-container",
        !IS_PC && "message-container-mobile"
      ];
      return className;
    });
    const buttons = computed(() => {
      const btnList = [];
      if (props.cancelText) {
        btnList.push({
          type: IS_PC ? "default" : "text",
          text: props.cancelText,
          customClasses: [!IS_PC && "message-box-footer-btn"],
          action: () => {
            handleClose("cancel");
          }
        });
      }
      if (props.confirmText) {
        btnList.push({
          type: IS_PC ? "primary" : "default",
          text: props.confirmText,
          customClasses: [!IS_PC && "message-box-footer-btn"],
          action: () => {
            handleClose("confirm");
          }
        });
      }
      return btnList;
    });
    function handleClose(action) {
      if (timer) {
        clearTimeout(timer);
        timer = null;
      }
      props.callback && props.callback(action);
      emit("update:visible", false);
      emit("close");
    }
    const handleMaskClick = () => {
      if (props.modal) {
        emit("update:visible", false);
        emit("close");
      }
    };
    function duration() {
      if (props.duration === Infinity) {
        return;
      }
      timer = setTimeout(() => {
        handleClose("close");
      }, props.duration);
    }
    const handelBtnAction = (btn) => {
      var _a;
      (_a = btn.action) == null ? void 0 : _a.call(btn);
    };
    onMounted(async () => {
      duration();
    });
    return (_ctx, _cache) => {
      return openBlock(), createBlock(Transition, { name: "fade" }, {
        default: withCtx(() => [
          withDirectives(createElementVNode("div", {
            class: normalizeClass(["message-box-mask", !_ctx.modal && "no-mask"]),
            onClick: withModifiers(handleMaskClick, ["self"])
          }, [
            createElementVNode("div", {
              class: normalizeClass([...messageBoxClassName.value])
            }, [
              createElementVNode("div", _hoisted_1, [
                renderSlot(_ctx.$slots, "header", {}, () => [
                  _ctx.type === "success" ? (openBlock(), createBlock(unref(IconSuccessToast), {
                    key: 0,
                    class: "message-type-icon"
                  })) : createCommentVNode("", true),
                  _ctx.type === "info" ? (openBlock(), createBlock(unref(IconInfoToast), {
                    key: 1,
                    class: "message-type-icon"
                  })) : createCommentVNode("", true),
                  _ctx.type === "error" ? (openBlock(), createBlock(unref(IconErrorToast), {
                    key: 2,
                    class: "message-type-icon"
                  })) : createCommentVNode("", true),
                  _ctx.type === "warning" ? (openBlock(), createBlock(unref(IconWarningToast), {
                    key: 3,
                    class: "message-type-icon"
                  })) : createCommentVNode("", true),
                  createElementVNode("span", _hoisted_2, toDisplayString(_ctx.title), 1),
                  _ctx.showClose && IS_PC ? (openBlock(), createBlock(unref(IconClose), {
                    key: 4,
                    class: "message-box-close-icon",
                    onClick: handleClose
                  })) : createCommentVNode("", true)
                ])
              ]),
              createElementVNode("div", _hoisted_3, [
                renderSlot(_ctx.$slots, "default", {}, () => [
                  createTextVNode(toDisplayString(_ctx.content), 1)
                ])
              ]),
              createElementVNode("div", _hoisted_4, [
                renderSlot(_ctx.$slots, "footer", {}, () => [
                  (openBlock(true), createElementBlock(Fragment, null, renderList(buttons.value, (btn) => {
                    return openBlock(), createBlock(unref(TUIButton), {
                      key: btn.text,
                      type: btn.type,
                      style: { "min-width": "88px" },
                      customClasses: btn.customClasses,
                      disabled: btn.disabled,
                      onClick: () => {
                        handelBtnAction(btn);
                      }
                    }, {
                      default: withCtx(() => [
                        createTextVNode(toDisplayString(btn.text), 1)
                      ]),
                      _: 2
                    }, 1032, ["type", "customClasses", "disabled", "onClick"]);
                  }), 128))
                ])
              ])
            ], 2)
          ], 2), [
            [vShow, _ctx.visible]
          ])
        ]),
        _: 3
      });
    };
  }
});
let instance = null;
let container = null;
const onRemove = () => {
  const appendTo = document.fullscreenElement || document.body;
  appendTo.removeChild(container);
  instance = null;
  container = null;
};
const createMessageBox = (options) => {
  container = document.createElement("div");
  const props = {
    ...options,
    "visible": true,
    "onUpdate:visible": (val) => {
      if (!val) {
        onRemove();
      }
    }
  };
  instance = createVNode(_sfc_main, props);
  (instance == null ? void 0 : instance.props) && (instance.props.onDestroy = () => {
    render(null, container);
  });
  (instance == null ? void 0 : instance.data) && (instance.data.onDestroy = () => {
    render(null, container);
  });
  render(instance, container);
  const appendTo = document.fullscreenElement || document.body;
  appendTo.appendChild(container);
  return instance;
};
const MessageBox = {
  alert: (config) => {
    if (instance) {
      onRemove();
    }
    instance = createMessageBox(config);
    return instance;
  }
};
export {
  MessageBox
};
