import type { ButtonType } from '../Button/types';
export type Action = 'cancel' | 'confirm' | 'close';
export type BeforeCloseFn = (action?: Action) => void;
export interface MessageBoxEvents {
    onConfirm?: () => void;
    onCancel?: () => void;
}
export interface MessageBoxOptions extends MessageBoxEvents {
    title?: string;
    type?: string;
    content?: string;
    modal?: boolean;
    showClose?: boolean;
    callback?: BeforeCloseFn | null;
    duration?: number;
    cancelText?: string;
    confirmText?: string;
    remove?: Function;
}
export interface MessageBoxProps extends MessageBoxOptions {
    visible: boolean;
}
export interface IMessageBoxBtn {
    type?: ButtonType;
    text?: string;
    customClasses?: string[];
    action?: () => void;
    disabled?: boolean;
}
