import { VNode } from 'vue';
import TOAST_TYPE from './type';
interface ITypeToast {
    message: string;
    offset?: number;
    duration?: number;
    onClose?(): void;
    showClose?: boolean;
    showIcon?: boolean;
}
interface IToast extends ITypeToast {
    type: TOAST_TYPE;
}
export interface IToastReturnType {
    close?(): void;
}
export declare function close(domId: string, userOnClose?: (vm: VNode) => void): void;
declare const TUIToast: {
    (options: IToast): IToastReturnType;
    close: typeof close;
    info(options: ITypeToast): IToastReturnType;
    success(options: ITypeToast): IToastReturnType;
    warning(options: ITypeToast): IToastReturnType;
    error(options: ITypeToast): IToastReturnType;
};
export { TUIToast, TOAST_TYPE };
