import { defineComponent, computed, createBlock, openBlock, Transition, withCtx, createElementBlock, createCommentVNode, withModifiers, normalizeClass, createElementVNode, renderSlot, toDisplayString, unref, createTextVNode, Fragment, renderList, createVNode, render } from "vue";
import { TUIButton } from "./components/Button/index.js";
import { g } from "./index.scss_vue_type_style_index_0_src_true_lang-DAMLZwbp.js";
import { E as IconClose } from "./index-B3QCMq6W.js";
import "./components/Toast/index.js";
import "./components/hooks/useComponent.js";
/* empty css                                                         */
const _hoisted_1 = { class: "dialog-header" };
const _hoisted_2 = { class: "dialog-title" };
const _hoisted_3 = { class: "dialog-body" };
const _hoisted_4 = { class: "dialog-footer" };
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "index",
  props: {
    visible: { type: Boolean, default: false },
    customClasses: { default: void 0 },
    title: { default: "" },
    content: { default: "" },
    modal: { type: Boolean, default: true },
    showClose: { type: Boolean, default: true },
    center: { type: Boolean, default: false },
    fullscreen: { type: Boolean, default: false },
    cancelText: { default: "取消" },
    confirmText: { default: "确认" },
    confirmDisabled: { type: Boolean, default: false },
    cancelDisabled: { type: Boolean, default: false },
    close: { type: Function, default: void 0 },
    confirm: { type: Function, default: void 0 },
    cancel: { type: Function, default: void 0 }
  },
  emits: ["update:visible", "close", "confirm", "cancel"],
  setup(__props, { emit: __emit }) {
    const IS_PC = g() === "pc";
    const props = __props;
    const emit = __emit;
    const close = () => {
      var _a;
      emit("update:visible", false);
      emit("close");
      (_a = props.close) == null ? void 0 : _a.call(props);
    };
    const dialogClassName = computed(() => {
      const className = [
        "dialog-container",
        props.center && "dialog-center",
        props.fullscreen ? "dialog-fullscreen" : "dialog-default",
        !IS_PC && "dialog-container-mobile"
      ];
      if (props.customClasses) {
        className.push(...props.customClasses);
      }
      return className;
    });
    const buttons = computed(() => {
      return [
        {
          type: IS_PC ? "default" : "text",
          text: props.cancelText,
          customClasses: [!IS_PC && "dialog-footer-btn"],
          disabled: props.cancelDisabled,
          action: () => {
            var _a;
            emit("cancel");
            (_a = props.cancel) == null ? void 0 : _a.call(props);
          }
        },
        {
          type: IS_PC ? "primary" : "default",
          text: props.confirmText,
          customClasses: [!IS_PC && "dialog-footer-btn"],
          disabled: props.confirmDisabled,
          action: () => {
            var _a;
            emit("confirm");
            (_a = props.confirm) == null ? void 0 : _a.call(props);
          }
        }
      ];
    });
    const handelBtnAction = (btn) => {
      var _a;
      (_a = btn.action) == null ? void 0 : _a.call(btn);
    };
    const handleMaskClick = () => {
      if (props.modal) {
        close();
      }
    };
    return (_ctx, _cache) => {
      return openBlock(), createBlock(Transition, { name: "fade" }, {
        default: withCtx(() => [
          _ctx.visible ? (openBlock(), createElementBlock("div", {
            key: 0,
            class: normalizeClass(["dialog-mask", !_ctx.modal && "no-mask"]),
            onClick: withModifiers(handleMaskClick, ["self"])
          }, [
            createElementVNode("div", {
              ref: "dialogRef",
              class: normalizeClass([...dialogClassName.value])
            }, [
              createElementVNode("div", _hoisted_1, [
                renderSlot(_ctx.$slots, "header", {}, () => [
                  createElementVNode("span", _hoisted_2, toDisplayString(_ctx.title), 1),
                  _ctx.showClose && IS_PC ? (openBlock(), createBlock(unref(IconClose), {
                    key: 0,
                    class: "close-icon",
                    onClick: close
                  })) : createCommentVNode("", true)
                ])
              ]),
              createElementVNode("div", _hoisted_3, [
                renderSlot(_ctx.$slots, "default", {}, () => [
                  createTextVNode(toDisplayString(_ctx.content), 1)
                ])
              ]),
              createElementVNode("div", _hoisted_4, [
                renderSlot(_ctx.$slots, "footer", {}, () => [
                  (openBlock(true), createElementBlock(Fragment, null, renderList(buttons.value, (btn) => {
                    return openBlock(), createBlock(unref(TUIButton), {
                      key: btn.text,
                      type: btn.type,
                      customClasses: btn.customClasses,
                      disabled: btn.disabled,
                      onClick: () => {
                        handelBtnAction(btn);
                      }
                    }, {
                      default: withCtx(() => [
                        createTextVNode(toDisplayString(btn.text), 1)
                      ]),
                      _: 2
                    }, 1032, ["type", "customClasses", "disabled", "onClick"]);
                  }), 128))
                ])
              ])
            ], 2)
          ], 2)) : createCommentVNode("", true)
        ]),
        _: 3
      });
    };
  }
});
let instance = null;
let container = null;
const createDialog = (options) => {
  container = document.createElement("div");
  const props = {
    ...options,
    visible: true,
    "onUpdate:visible": (val) => {
      if (!val) destroy();
    }
  };
  instance = createVNode(_sfc_main, props);
  (instance == null ? void 0 : instance.props) && (instance.props.onDestroy = () => {
    render(null, container);
  });
  (instance == null ? void 0 : instance.data) && (instance.data.onDestroy = () => {
    render(null, container);
  });
  render(instance, container);
  const appendTo = document.fullscreenElement || document.body;
  appendTo.appendChild(container);
  return instance;
};
const destroy = () => {
  const appendTo = document.fullscreenElement || document.body;
  appendTo.removeChild(container);
  instance = null;
  container = null;
};
const dialog = {
  open: (config) => {
    if (instance) destroy();
    instance = createDialog(config);
    return instance;
  },
  close: () => {
    var _a, _b, _c;
    return (_c = (_b = (_a = instance == null ? void 0 : instance.component) == null ? void 0 : _a.ctx) == null ? void 0 : _b.$emit) == null ? void 0 : _c.call(_b, "update:visible", false);
  }
};
export {
  _sfc_main as _,
  dialog as d
};
