import { ref, reactive } from "vue";
import i18nextInnerInstance from "../../i18n/index.js";
const language = ref("en-US");
function useLanguage() {
  function setLanguage(lng) {
    i18nextInnerInstance.changeLanguage(lng);
    language.value = lng;
  }
  const languageContext = reactive({
    get language() {
      return language.value;
    },
    setLanguage,
    t: i18nextInnerInstance.t.bind(i18nextInnerInstance),
    i18n: i18nextInnerInstance
  });
  return languageContext;
}
function addLanguageResources(languageResources) {
  languageResources.forEach((languageResource) => {
    i18nextInnerInstance.addResourceBundle(
      languageResource.lng,
      "translation",
      languageResource.translation,
      true,
      false
    );
  });
}
export {
  addLanguageResources,
  useLanguage
};
