import { ref } from "vue";
import { ThemeColorGenerator } from "./colorGenerator.js";
const theme = ref();
function useTheme() {
  function setTheme(newTheme) {
    theme.value = typeof newTheme === "object" ? newTheme.themeStyle : newTheme;
    document.documentElement.setAttribute("tui-theme-mode", `${theme.value}`);
    if (typeof newTheme === "object" && newTheme.primaryColor) {
      const color = newTheme.primaryColor;
      if (color.match(/^#[0-9A-Fa-f]{6}$/)) {
        document.documentElement.style.setProperty("--primary-color", color);
        ThemeColorGenerator.applyThemeColor(color);
      } else {
        console.warn(`Invalid color format: ${color}`);
      }
    }
  }
  return {
    theme,
    setTheme
  };
}
export {
  useTheme
};
